import dataclasses

from ..algebra.vector import Vector2D


@dataclasses.dataclass
class Triangle:
    p0: Vector2D
    p1: Vector2D
    p2: Vector2D


def triangle_area(t: Triangle) -> float:
    p1 = t.p1 - t.p0
    p2 = t.p2 - t.p0
    return abs(p1.cross(p2) / 2)
