# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['dsalgo',
 'dsalgo.algebra',
 'dsalgo.algebra.abstract',
 'dsalgo.algebra.fft',
 'dsalgo.algebra.fft.cooley_turkey',
 'dsalgo.algebra.fft.gentleman_sande',
 'dsalgo.algebra.fft.recursive',
 'dsalgo.algebra.fft.stackham',
 'dsalgo.algebra.matrix',
 'dsalgo.algebra.matrix.xor_and',
 'dsalgo.algebra.taylor_series',
 'dsalgo.analysis',
 'dsalgo.combinatorics',
 'dsalgo.combinatorics.combinations',
 'dsalgo.combinatorics.combinations.with_nxt_cmb',
 'dsalgo.combinatorics.next_combination',
 'dsalgo.combinatorics.next_permutation',
 'dsalgo.combinatorics.next_repeated_permutation',
 'dsalgo.combinatorics.permutations',
 'dsalgo.combinatorics.permutations.with_nxt_perm',
 'dsalgo.combinatorics.repeated_combinations',
 'dsalgo.combinatorics.repeated_combinations.bfs',
 'dsalgo.combinatorics.repeated_combinations.dfs',
 'dsalgo.combinatorics.repeated_combinations.dfs.non_recursive',
 'dsalgo.combinatorics.repeated_combinations.dfs.recursive',
 'dsalgo.combinatorics.repeated_permutations',
 'dsalgo.combinatorics.repeated_permutations.bfs',
 'dsalgo.combinatorics.repeated_permutations.dfs',
 'dsalgo.combinatorics.repeated_permutations.dfs.non_recursive',
 'dsalgo.combinatorics.repeated_permutations.dfs.recursive',
 'dsalgo.container',
 'dsalgo.container.deque',
 'dsalgo.container.deque.dynamic_array',
 'dsalgo.container.fifo_queue',
 'dsalgo.container.multiset',
 'dsalgo.container.multiset.fenwick',
 'dsalgo.container.multiset.segtree',
 'dsalgo.dp',
 'dsalgo.geometry',
 'dsalgo.graph_theory',
 'dsalgo.graph_theory.lca',
 'dsalgo.graph_theory.lca.eulertour_rmq',
 'dsalgo.graph_theory.maximum_flow',
 'dsalgo.graph_theory.maze',
 'dsalgo.graph_theory.mst',
 'dsalgo.graph_theory.tree',
 'dsalgo.graph_theory.tree.segment_tree',
 'dsalgo.graph_theory.tree.splay_tree',
 'dsalgo.misc',
 'dsalgo.misc.query',
 'dsalgo.misc.query.setpointgetrange',
 'dsalgo.misc.query.setrangegetpoint',
 'dsalgo.misc.query.setrangegetrange',
 'dsalgo.numba',
 'dsalgo.numba.algebra',
 'dsalgo.numba.algebra.abstruct',
 'dsalgo.numba.algebra.matrix',
 'dsalgo.numba.combinatorics',
 'dsalgo.numba.container.deque.dynamic_array',
 'dsalgo.numba.container.fifo_queue',
 'dsalgo.numba.dp',
 'dsalgo.numba.graph_theory',
 'dsalgo.numba.graph_theory.lca',
 'dsalgo.numba.graph_theory.lca.eulertour_rmq',
 'dsalgo.numba.graph_theory.lca.eulertour_rmq.segtree',
 'dsalgo.numba.graph_theory.maximum_flow',
 'dsalgo.numba.graph_theory.mst',
 'dsalgo.numba.graph_theory.tree',
 'dsalgo.numba.number_theory',
 'dsalgo.numba.query.segpointgetrange',
 'dsalgo.numba.query.setrangegetpoint',
 'dsalgo.numba.query.setrangegetrange',
 'dsalgo.numba.string',
 'dsalgo.number_theory',
 'dsalgo.numpy',
 'dsalgo.sort',
 'dsalgo.string',
 'dsalgo.topology']

package_data = \
{'': ['*']}

install_requires = \
['networkx>=2,<3', 'numba>=0,<1', 'numpy>=1,<2', 'scipy>=1,<2']

setup_kwargs = {
    'name': 'dsalgo',
    'version': '0.1.0',
    'description': 'A package for datastructures and algorithms.',
    'long_description': None,
    'author': 'Hiroshi Tsuyuki',
    'author_email': 'kagemeka1@gmail.com',
    'maintainer': None,
    'maintainer_email': None,
    'url': None,
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.9,<3.10',
}


setup(**setup_kwargs)
